<html>
<head>
  <title>./7_wan_event/wan_property.c</title>
</head>
<body bgcolor="#ffffff" text="#000000">
<pre>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-listen-event.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;pthread.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;signal.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdio.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdlib.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;string.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;unistd.h&gt;</font></strong></font>

<strong>int</strong> <font color="#2040a0">stop_flag</font> <font color="4444FF">=</font> <font color="#FF0000">1</font><font color="4444FF">;</font>

<strong>int</strong> <font color="#2040a0">get_cb</font><font color="4444FF">(</font><strong>const</strong> <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">property_name</font>, <strong>const</strong> <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">property_value</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;property_name: %s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">property_name</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;property_value: %s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">property_value</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#FF0000">0</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>void</strong> <font color="#2040a0">sighandler</font><font color="4444FF">(</font><strong>int</strong> <font color="#2040a0">signum</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Caught signal %d, coming out...<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">signum</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">stop_flag</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>void</strong> <font color="#2040a0">listen_wan_property_changed</font><font color="4444FF">(</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <font color="#2040a0">event_context</font> <font color="4444FF">*</font><font color="#2040a0">context</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_init_property_changed_event_context</font><font color="4444FF">(</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>int</strong> <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_subscribe_properties_changed_wan</font><font color="4444FF">(</font><font color="#2040a0">context</font>, <font color="#2040a0">get_cb</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: listen interface(%s) property cheanged failed :%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">mcm_start_listen_subscribe_properties_changed_event</font><font color="4444FF">(</font><font color="#2040a0">context</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>while</strong> <font color="4444FF">(</font><font color="#2040a0">stop_flag</font><font color="4444FF">)</font>
        <font color="4444FF">;</font>

    <font color="#2040a0">mcm_stop_listen_subscribe_properties_changed_event</font><font color="4444FF">(</font><font color="#2040a0">context</font><font color="4444FF">)</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">main</font><font color="4444FF">(</font><strong>int</strong> <font color="#2040a0">argc</font>, <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="4444FF">]</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <font color="#2040a0">signal</font><font color="4444FF">(</font><font color="#2040a0">SIGINT</font>, <font color="#2040a0">sighandler</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <font color="#2040a0">listen_wan_property_changed</font><font color="4444FF">(</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>return</strong> <font color="#FF0000">0</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

</pre>
<hr>
syntax highlighted by <a href="http://www.palfrader.org/code2html">Code2HTML</a>, v. 0.9.1
</body>
</html>
